/* $Id: planet.java,v 1.50 2004/04/07 14:18:34 mit Exp $ */
/* planet.java (planetarium) */
import java.applet.*; 
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.text.*;
import java.io.*;
import java.net.*;

public class planet extends Applet 
    implements MouseListener, MouseMotionListener, Runnable
{
    final int CONST = 88; // link$BG[Ns(B($B@1:B?t(B)
    final int LINES = 19; // " (1$B@1:B$N:GBg?t(B)
    final double PI2 = 2*Math.PI;
    final double K4 = Math.cos(toRadians(23.44579)); // $B2+F;79<P3Q(B
    final double K5 = Math.sin(toRadians(23.44579)); // " (1950$BG/J,E@(B)
    private Canvas can;
    private Thread thr;

    Stars [] S;
    boolean MSW; // move sw.
    boolean LSW; // line sw.
    boolean ISW; // link sw.
    boolean RUN;
    boolean MET;
    int HEIGHT;
    int WIDTH;
    int FNT;
    int FNS;
    int DY;
    int DT;
    int YY;
    int MM;
    int DD;
    int HH;
    int MS;
    int mX;
    int mY;
    int Ds, Dp; // sun/planet dot
    int MEX, MEY; // meteor
    int [] DO;  // stars dot
    //int [] RD; // for planet
    double LG; // your$B7PEY(B(longitude)
    double LA; // your$B0^EY(B(latiotude)
    double JD; // julian day
    double LD; // local time
    double LF;
    double RG;
    double DW;
    double TT;
    double DH;
    double T1;
    double T2;
    double TY;
    double SS;
    double CC;
    double FF;
    double TA;

    double Am; // for moon
    double Bm;
    double Cm;
    double Dm;
    double Em;
    double Gm;
    //double Jm;
    //double Lm;
    //double Mm;
    double Nm;
    //double Vm;
    double Wm;
    double MX;
    double MY;
    double MZ;

    double LST;
    double [] E;
    double [] M;
    double [] P;
    double [] N;
    double [] I;
    double [] A;
    double [] F;
    double [] Q;
    String error;
    Point Met, Mes;
    Point [][] SL;
    String [] Planets = {"Mercury","Venus","Sun","Mars",
			 "Jupiter","Saturn","Uranus",
			 "Neptune","Pluto"};
    Color [] Pclr = {Color.cyan, Color.yellow, Color.yellow, Color.red,
		     Color.orange, Color.pink, new Color(0,100,255), 
		     new Color(50,50,255), new Color(100,0,255)}; // $BOG@1?'(B
    Color [] Clr = {Color.blue, new Color(120,210,255), 
		    new Color(230,230,255), new Color(220,220,100),
		    new Color(255,190,30), new Color(250,130,90),
		    Color.red, new Color(255,0,145)};        // obafgkmn$B@1?'(B
    Color Bln = new Color(40, 0, 180);  // link$B?'(B
    Color Rln = new Color(140, 0, 40);  // $B@VF;?'(B
    Color Yln = new Color(120, 140, 0); // $B2+F;?'(B

    Graphics gi;
    Image im;
    Font Fnt;
    FontMetrics fm;
    DecimalFormat df1;

    public void init() {
	String fnt = getParameter("font");
	FNT = (fnt != null) ? Integer.parseInt(fnt) : 12; //
	Fnt = new Font("SansSerif", Font.PLAIN, FNT);
	setFont(Fnt);
        fm = getFontMetrics(Fnt);
	df1 = new DecimalFormat("#0.0");

	String lon = getParameter("longitude");
	LD = LG = toRadians((lon != null) ? Double.valueOf(lon).doubleValue() : 139.745);
	String lat = getParameter("latiotude");
	LA = toRadians((lat != null) ? Double.valueOf(lat).doubleValue() : 35.654);

	setBackground(Color.lightGray);
        setLayout(new BorderLayout());
	can = new MyCanvas();
	add(can, "Center");

	can.addMouseListener(this);
	can.addMouseMotionListener(this);

	String dn = getParameter("data_number");
	int num = (dn != null) ? Integer.parseInt(dn) : 1750;
	S = new Stars[num];
	String df = getParameter("data_file");
	df = (df != null) ? df : "star.dat";
	read_file(df);
    }
    public void start() {
	E = new double[Planets.length];
	M = new double[Planets.length];
	P = new double[Planets.length];
	N = new double[Planets.length];
	I = new double[Planets.length];
	A = new double[Planets.length];
	//RD = new int[Planets.length];

	WIDTH = getSize().width;
        HEIGHT = getSize().height;

	can.setSize(WIDTH, HEIGHT);
	im = createImage(WIDTH, HEIGHT);
        gi = im.getGraphics();

	DW = PI2/(WIDTH-1);      // 360$B!k(B
	DH = Math.PI/(HEIGHT-1); // 180$B!k(B

	init_line(); //
	set_date();
	set_jd();
	set_dot();
	init_meteor();
    }

    public void mousePressed(MouseEvent m) {}
    public void mouseClicked(MouseEvent m) {
	int mget = m.getModifiers();
	if (m.isShiftDown())
	    LSW = !LSW;    // line disp.
	else if (m.isControlDown())
	    ISW = !ISW;    // link disp.
	else if (m.isMetaDown()) {
	    if (MSW) {
		RUN = !RUN;
		thr = new Thread(this);
		thr.start();  // run
	    }
	} else
	    MSW = !MSW;  // move sw.
	can.repaint();
    }
    public void mouseReleased(MouseEvent m) {}
    public void mouseEntered(MouseEvent m) {}
    public void mouseExited (MouseEvent m) {}
    public void mouseMoved(MouseEvent me) {
	mX = me.getX();
	mY = me.getY();
	if (!MSW) { //
	    RUN = false;
	    TT = DW*mX;
	    set_wide();
	}
	can.repaint();
    }
    public void mouseDragged(MouseEvent me) {
	int mx = me.getX();
	int my = me.getY();
	RUN = false;

	LG = DW*mx;
	if (LG < 0)
	    LG = 0;
	else if (LG > PI2)
	    LG = PI2;

	LA = Math.PI/2-DH*my;
	if (LA < -Math.PI/2)
	    LA = -Math.PI/2;
	else if (LA > Math.PI/2)
	    LA = Math.PI/2;

	can.repaint();
    }
    public void set_wide() {
	LF = TT-Math.PI/2;
	RG = TT+Math.PI/2;
    }
    public void run() {
	try {
	    while(RUN) {
		HH += 1;
		if (HH > 24) {
		    HH = 1;
		    DD++;
		}
		set_jd();
		can.repaint();
		thr.sleep(2000);
	    }
	} catch (InterruptedException e) {
	    System.out.println(e);
	}
    }
    public void stop() {
        if (thr != null)
            thr = null;
    }

    public double toRadians(double d) { // (jdk1.1.8)
	return d*Math.PI/180.0;
    }
    public double toDegrees(double r) { // (jdk1.1.8)
	return r*180.0/Math.PI;
    }
    public int sgn(int n) {
	return (n < 0) ? -1 : 1;
    }
    public void set_date() {
	//*
	Calendar cal = new GregorianCalendar(TimeZone.getTimeZone("JST"));
	YY = cal.get(Calendar.YEAR);
	MM = cal.get(Calendar.MONTH)+1; //
	DD = cal.get(Calendar.DATE);
	HH = cal.get(Calendar.HOUR_OF_DAY);
	MS = cal.get(Calendar.MINUTE);
	/* 
	YY = 1981; // for check
	MM = 1;
	DD = 1;
	HH = 10;
	MS = 0;
	*/
    }
    public void set_jd() {
	jurian();
	JD += HH/24.0+MS/1440.0;
	JD -= ((int)(toDegrees(LG)/15)/24.0);
    }
    public void jurian() {
	double year = 365.25;
	double month = 30.59;
	double julian = 1582.78;
	double p5 = YY+(MM-1)/12+DD/year;
	if (MM <= 2) {
	    MM += 12;
	    YY -= 1;
	}
	if (p5 >= julian) {
	    JD = (int)(year*YY)+(int)(YY/400)-(int)(YY/100)+
		(int)(month*(MM-2))-678912;
	} else {
	    if (YY < 0) {
		int s1 = sgn(YY);
		YY = Math.abs(YY);
		JD = s1*(int)(year*YY)+(int)(month*(MM-2))-678914;
		YY *= s1;
	    } else
		JD = (int)(year*YY)+(int)(month*(MM-2))-678915;
	}
	JD += DD;
	if (MM > 12) {
	    MM -= 12;
	    YY += 1;
	}
    }/*
    public double kouseiji_1950(double r2) {
	double r3 = 0.6705199+1.002737803*(JD-40000)+r2/(PI2);
	return getFrc(r3)*PI2;
	}*/
    public double kouseiji_data(double r2) {
	double r3 = 0.671262+1.002737909*(JD-40000)+r2/(PI2);
	return getFrc(r3)*PI2;
    }
    public double syogen(double ss, double cc) {
	double tt = Math.atan(ss/cc);
	if (cc <= 0)
	    tt += Math.PI;
	else if (ss <= 0)
	    tt += PI2;
	return tt;
    }
    public Point hanen(double [] dt) {
	return hanen(dt[0], dt[1]);
    }
    public Point hanen(double al, double hi) {
	al -= TT; // ??
	if (hi == 0)
	    hi = 0.000001;
        double cc = Math.cos(hi)*Math.cos(al);
	double qq = Math.acos(cc);
	qq = (qq > Math.PI/2) ? qq-Math.PI : qq;
	
	double ss = Math.sin(al)*Math.cos(hi)/Math.sin(qq);
	double vv = Math.asin(ss);
        double ro = qq*HEIGHT/2;
	double y = ro*Math.cos(vv);
	double x = ro*Math.sin(vv);
        Point xy = new Point((int)(x+WIDTH/2), (int)(HEIGHT-y));
        return xy;
    }
    public void kepler(double ec, double mo) {
	double a1 = 0;
	double a2 = ec*Math.sin(a1+mo); // mo$B%O(BRadian
	while (Math.abs(a2-a1) > 1E-5) {
	    /* System.out.println(""+(float)a1+" "+(float)a2); */
	    a1 = a2;
	    a2 = ec*Math.sin(a1+mo);
	}
	a1 = a2+mo;
	/* System.out.println("E = "+toDegrees(a1)); */
	SS = Math.sin(a1);
	CC = Math.cos(a1);
	FF = CC-ec;
    }
    public void eph_const(double pe, double nd, double ic) {
	double r1 = Math.sin(pe);
	double r2 = Math.sin(nd);
	double r3 = Math.sin(ic);
	double r4 = Math.cos(pe);
	double r5 = Math.cos(nd);
	double r6 = Math.cos(ic);
	F = new double[3];
	Q = new double[3];
	F[0] = r5*r4-r1*r6*r2;
	Q[0] = -r1*r5-r4*r6*r2;
	double r7 = r6*r5*K4;
	double r8 = r2*K4;
	double r9 = r3*K5;
	F[1] = r1*r7+r4*r8-r1*r9;
	Q[1] = r4*r7-r1*r8-r4*r9;
	r7 = r3*K4;
	r8 = r6*r5*K5;
	r9 = r2*K5;
	F[2] = r1*r7+r1*r8+r4*r9;
	Q[2] = r4*r7+r4*r8-r1*r9;
    }
    public void set_planet(int p) {
	switch (p) {
	case 0: // mercury
	    E[0] = 0.20562441+2.042E-5*T1+8.242E-8*T2;
	    M[0] = -0.729180963+2608.731797*T1+8.242E-8*T2;
	    P[0] = 0.505094601+4.98049095E-3*T1+1.33324E-6*T2;
	    N[0] = 0.833197496-2.1919881E-3*T1+1.57564E-6*T2;
	    I[0] = 0.122238982-1.0510761E-4*T1+1.454E-8*T2;
	    A[0] = 0.3870986011;
	    //RD[0] = 2439; // $B:#2s$OL$;HMQ(B
	    break;
	case 1: // venus
	    E[1] = 6.79676E-03-4.773E-5*T1+9E-8*T2;
	    M[1] = -0.848503209+1021.306597*T1+2.259232E-5*T2;
	    P[1] = 0.953579254+4.99862298E-3*T1-2.077911E-5*T2;
	    N[1] = 1.330454065-4.85584535E-3*T1-1.78896E-6*T2;
	    I[1] = 0.059237299-1.798659E-5*T1-5.6723E-7*T2;
	    A[1] = 0.7233316286;
	    //RD[1] = 6052;
	    break;
	case 2: // earth
	    E[2] = 0.01673012-4.192E-5*T1-1.3E-7*T2;
	    M[2] = -0.036149841+628.288592*T1-2.86525E-6*T2;
	    P[2] = -1.262568078+9.7864E-3*T1+2.55497E-6*T2;
	    N[2] = 3.044140013-4.21225519E-3*T1+2.0847E-7*T2;
	    I[2] = 2.2713521E-4*T1-2.618E-7*T2;
	    A[2] = 1.00000023;
	    //RD[2] = 695989; 
	    break;
	case 3: // mars
	    E[3] = 0.09335426+9.056E-5*T1-7E-8*T2;
	    M[3] = -3.326348457+334.0465218*T1+3.08342E-6*T2;
	    P[3] = 4.991059739+0.01288077229*T1+7.98973E-6*T2;
	    N[3] = 0.858200646-5.14922660E-3*T1-1.107314E-5*T2;
	    I[3] = 0.032288058-1.4539562E-4*T1-3.9755E-7*T2;
	    A[3] = 1.523688174;
	    //RD[3] = 3397;
	    break;
	case 4: // jupiter
	    E[4] = 0.04827062+4.7756E-5*T1+2.2676E-5*T2;
	    M[4] = 5.28677165+52.96844784*T1+9.996858E-5*T2;
	    P[4] = -1.50945736-1.7239975E-4*T1+1.885925E-5*T2;
	    N[4] = 1.741507757+3.204618E-5*T1+9.40539E-6*T2;
	    I[4] = 0.0228307+7.8055E-7*T1+3.6991E-7*T2;
	    A[4] = 5.202833481;
	    //RD[4] = 71398;
	    break;
	case 5:	// saturn
	    E[5] = 0.05604508-2.5595E-5*T1-1.6172E-5*T2;
	    M[5] = 1.165262433+21.328205912*T1-5.4580324E-4*T2;
	    P[5] = -0.38321152+4.2707237E-4*T1+2.6548394E-4*T2;
	    N[5] = 1.980742073+3.005845E-5*T1-5.657776E-5*T2;
	    I[5] = 0.043422822+8.69756E-6*T1+3.56823E-6*T2;
	    A[5] = 9.538762055;
	    //RD[5] = 60000;
	    break;
	case 6: // uranus
	    E[6] = 0.04613734-4.8118E-5*T1+1.5396E-5*T2;
	    M[6] = -1.273611261+7.479637598*T1+8.2743151E-4*T2;
	    P[6] = 1.716582467-2.37485982E-3*T1-8.1424458E-4*T2;
	    N[6] = 1.28641873+6.429559E-4*T1+3.97547E-6*T2;
	    I[6] = 0.013501673-1.72933E-5*T1-8.7412E-7*T2;
	    A[6] = 19.19139128;
	    //RD[6] = 25400;
	    break;
	case 7: // neptune
	    E[7] = 9.71449E-03+1.095407E-3*T1+3.62034E-4*T2;
	    M[7] = 2.724754505+3.994465294*T1+0.0483557044*T2;
	    P[7] = -1.62194737-0.18123685121*T1-0.048352097*T2;
	    N[7] = 2.290559396+4.467073E-5*T1-1.844231E-5*T2;
	    I[7] = 0.03096505-3.001E-6*T1+3.6216E-7*T2;
	    A[7] = 30.06106906;
	    //RD[7] = 24300;
	    break;
	case 8: // pluto
	    E[8] = 0.24824802+4.97082E-4*T1+5.63208E-4*T2;
	    M[8] = -0.999328454+2.553487672*T1+6.86515565E-3*T2;
	    P[8] = 1.977072713-0.01828324506*T1-6.76126008E-3*T2;
	    N[8] = 1.913508742+1.027805E-5*T1+5.6820159E-5*T2;
	    I[8] = 0.29929226+1.5198909E-4*T1+5.269925E-5*T2;
	    A[8] = 39.52940243;
	    //RD[8] = 1500;
	    break;
	default:
	}
    }
 
    class MyCanvas extends Canvas {
	public void update(Graphics g) {
	    can.paint(g);
	}
	public void paint(Graphics g) {
	    paintI();
	    g.drawImage(im, 0, 0, this);
	}
    }
    public void paintI() {
	gi.setColor(Color.black);
        gi.fillRect(0, 0, WIDTH, HEIGHT);

	LST = kouseiji_data(LG);

	if (LSW) {
	    disp_dc_line(gi);
	    disp_ra_line(gi);
	    disp_ecliptic(gi);
	    disp_test(gi);
	    disp_size(gi);
	}
	if (MSW && ISW)
	    init_line(); // link$B;~$N$_(B
	disp_stars(gi);
	if (MSW && ISW) {
	    disp_line(gi);
	    disp_stars(gi); // link$B8e:FIA2h(B
	}
	disp_planet(gi);
	disp_moon(gi);

	if (Math.random() > 0.93)
	    MET = false;
	disp_meteor(gi);

	if (!error.equals(""))
	    showStatus(error);
    }
    public void init_meteor() {
	int x = WIDTH/2;
	int y = HEIGHT/4;
	Met = new Point(x, y);
	Mes = new Point(x, y);
    }
    public void set_meteor() {
	MEX = (Math.random() < 0.5) ? -15 : 15;
	MEY = 10;
	Mes.translate(MEX, MEY);
	MET = true;
    }
    public void disp_meteor(Graphics g) {
	if (!MET)
	    set_meteor();
	if (Met.y > HEIGHT)
	    return;
	Met.translate(MEX, MEY);
	Mes.translate(MEX, MEY);
	g.setColor(Color.gray);
	g.drawLine(Met.x, Met.y, Mes.x, Mes.y);

	//showStatus("mex:"+MEX+" mey:"+MEY);
	//System.out.println(Met.x, Met.y);
    }
    public void disp_size(Graphics g) {
	int x = FNT;
	int y = FNT*3;
	int dy = (DO[0] > 1) ? DO[0]*2 : 3;
	g.setColor(Clr[1]);
	for (int i = 0; i < DO.length; i++) {
	    int iy = y+dy*i;
	    if (DO[i] == 1) // for jdk1.1.8
		gi.drawLine(x, iy, x, iy);
	    else
		gi.fillOval(x, iy, DO[i], DO[i]);
	    /* g.drawString(""+(DO.length-DO[i]), x+FNT, iy); */
	}
    }
    public void disp_test(Graphics g) {
	int dx = FNT, sft = FNT/2;
	int y = FNT*2+sft, xx, ys = FNT*4;
	String spec = "OBAFGKMN";
	int len = fm.stringWidth(spec); // ?
	int x = WIDTH-len-(int)(FNT*1.5);
	int dot = (Dp == 2) ? 3 : Dp; // for 2k?
	for (int i = 0; i < Clr.length; i++) {
	    xx = x+dx*i;
	    g.setColor(Clr[i]);
	    g.fillOval(xx, y, Dp, Dp);

	    g.setColor(Color.red);
	    g.drawString(spec.substring(i, i+1), xx-2, ys);
	}
    }
    public void disp_stars(Graphics g) {
	Point p;
	int dot, st = -1, mw = 3, cl;
	double ra, dc, mg, hagl, azmt, hgt;
	for (int i = 0; i < S[0].getAllnum(); i++) {
	    ra = S[i].getRA();
	    dc = S[i].getDC();
	    cl = S[i].getColor();
	    mg = S[i].getCandela();

	    hagl = LST-ra;
	    hgt = getHgt(dc, hagl);
	    if (hgt < toRadians(0.1))
		continue;
	    azmt = getAzmt(dc, hagl);
	    if (azmt >= RG && azmt <= LF)
		continue;
	    
	    p = hanen(azmt, hgt);	  
	    if (MSW)
		set_line(i, p);

	    dot = get_dot(mg);
	    gi.setColor(Clr[cl]);
	    if (dot == 1) // for jdk1.1.8?
		gi.drawLine(p.x, p.y, p.x, p.y);
	    else
		gi.fillOval(p.x, p.y, dot,dot);

	    if (mX-mw < p.x && mX > p.x && mY-mw < p.y && mY > p.y)
		st = i;
	}
	disp_text(gi, st);
    }
    public void set_dot() {
	DO = new int[6];
	Ds = FNT/2+1;
	Dp = Ds-3;
	DO[0] = (Dp == 2) ? 1 : Dp; // for 2k?
	DO[1] = (DO[0] > 1) ? DO[0]-1 : 1;
	DO[2] = (DO[1] > 1) ? DO[1]-1 : 1;
	DO[3] = (DO[2] > 1) ? DO[2]-1 : 1;
	DO[4] = (DO[3] > 1) ? DO[3]-1 : 1;
	DO[5] = (DO[4] > 1) ? DO[4]-1 : 1;
    }
    public int get_dot(double can) {
	if (can < 1.0)
	    return DO[0];
	else if (can < 2.0)
	    return DO[1];
	else if (can < 3.0)
	    return DO[2];
	else if (can < 4.0)
	    return DO[3];
	else if (can < 5.0)
	    return DO[4];
	else
	    return DO[5];
    }
    public void disp_line(Graphics g) {
	int min = 4;
	Point p1;
	g.setColor(Bln);
	for (int i = 0; i < CONST; i++) {
	    p1 = new Point(0, 0);
	    for (int j = 1; j < LINES; j++) { // 1~
		if (SL[i][j] == null)
		    continue;
		if (p1.x > 0 && (SL[i][j].y < HEIGHT-min) && (p1.y < HEIGHT-min))
		    g.drawLine(p1.x, p1.y, SL[i][j].x, SL[i][j].y);
		p1 = SL[i][j];
	    }
	}
    }
    public void set_line(int n, Point p) {
	int st = S[n].getNum();
	int x = S[n].getLink();
	if (x <= 0)
	    return;
	if (x > 10000) {
	    SL[st][x/10000] = p;
	    x %= 10000;
	}
	if (x > 100) {
	    SL[st][x/100] = p;
	    SL[st][x%100] = p;
	} else if (x > 13) {
	    SL[st][x/10] = p;
	    SL[st][x%10] = p;
	} else {
	    SL[st][x] = p;
	}
    }
    public void init_line() {
	SL = new Point[CONST][LINES];
    }
    public double getHgt(double dc, double gl) {
	return Math.asin(calc_xsin(dc, gl));
    }
    public double getAzmt(double dc, double al) {
	double xcos = calc_xcos(dc, al);
	if (xcos == 0)
	    xcos = 0.000001;
	return getDatn2(calc_cos_sin(dc, al), xcos);
    }
    public double getDatn2(double s, double c) {
	int sw1 = (c < 0) ? 1 : 0;
	int sw2 = (c > 0 && s <= 0) ? 1 : 0;
	return Math.atan(s/c)-Math.PI*sw1-PI2*sw2;
    }
    public double getFrc(double n) {
	return n-(int)n;
    }
    public double calc_xcos(double dc, double al) {
	return Math.cos(dc)*Math.sin(LA)*Math.cos(al)-
	    Math.sin(dc)*Math.cos(LA);
    }
    public double calc_xsin(double dc, double al) {
	return Math.sin(dc)*Math.sin(LA)+
	    Math.cos(dc)*Math.cos(LA)*Math.cos(al);
    }
    public double calc_cos_sin(double dc, double al) {
	return Math.cos(dc)*Math.sin(al);
    }
    public void disp_dc_line(Graphics g) {
	double dc, hgt, hagl, azmt;
	Point p, p1;
	for (int i = 80; i > -90; i -= 10) {
	    p1 = new Point(0, 0);
	    dc = toRadians(i);
	    g.setColor((i == 0) ? Rln : Color.darkGray);
	    for (int l = 1; l < 366; l += 5) {
		hagl = LST-toRadians(l);
		hgt = getHgt(dc, hagl);
		if (hgt < toRadians(0.1)) {
		    p1 = new Point(0, 0);
		    continue;
		}
		azmt = getAzmt(dc, hagl);
		if (azmt >= RG && azmt <= LF) {
		    p1 = new Point(0, 0);
		    continue;
		}
		p = hanen(azmt, hgt);
		if (p1.x > 0 && (p.y < HEIGHT-1) && (p1.y < HEIGHT-1))
		    g.drawLine(p1.x, p1.y, p.x, p.y);
		p1 = p;
	    }
	}
    }
    public void disp_ra_line(Graphics g) {
	double dc, hgt, hagl, azmt;
	Point p, p1;
	g.setColor(Color.darkGray);
	for (int i = 0; i < 365; i += 15) { // 345
	    p1 = new Point(0, 0);
	    hagl = LST-toRadians(i);
	    for (int l = 90; l > -96; l -= 5) {
		dc = toRadians(l);
		hgt = getHgt(dc, hagl);
		if (hgt < toRadians(0.1)) {
		    p1 = new Point(0, 0);
		    continue;
		}
		azmt = getAzmt(dc, hagl);
		if (azmt >= RG && azmt <= LF) {
		    p1 = new Point(0, 0);
		    continue;
		}
		p = hanen(azmt, hgt);
		if (p1.x > 0 && (p.y < HEIGHT-1) && (p1.y < HEIGHT-1))
		    g.drawLine(p1.x, p1.y, p.x, p.y);
		p1 = p;
	    }
	}
    }
    public void disp_ecliptic(Graphics g) {
	double gl, cra, sra, sdc, dc, ra, hagl, hgt, azmt;
	Point p, p1 = new Point(0, 0);
	g.setColor(Yln);
	for (int i = 1; i < 366; i += 5) {
	    gl = toRadians(i);
	    cra = Math.cos(gl);
	    sra = Math.sin(gl)*K4;
	    sdc = Math.sin(gl)*K5;
	    ra = getDatn2(sra, cra);
	    dc = Math.atan(sdc*Math.cos(ra)/cra);

	    hagl = LST-ra;
	    hgt = getHgt(dc, hagl);
	    if (hgt < toRadians(0.1)) {
		p1 = new Point(0, 0);
		continue;
	    }
	    azmt = getAzmt(dc, hagl);
	    if (azmt >= RG && azmt <= LF) {
		p1 = new Point(0, 0);
		continue;
	    }
	    p = hanen(azmt, hgt);
	    if (p1.x > 0 && (p.y < HEIGHT-1) && (p1.y < HEIGHT-1))
		g.drawLine(p1.x, p1.y, p.x, p.y);
	    p1 = p;
	}
    }
    public void disp_text(Graphics g, int st) {
	String as = "Latiotude:"+(int)toDegrees(LA);
	String gs = "Longitude:"+(int)toDegrees(LG);
	int la = fm.stringWidth(as);
	int lg = fm.stringWidth(gs);
	g.setColor(Color.red);
	g.drawString(as, WIDTH-la, FNT);
	g.drawString(gs, WIDTH-lg, FNT*2);

	String ts ="C.:"+(int)toDegrees(TT);
	int lt = fm.stringWidth(ts);
	g.drawString(ts, WIDTH/2-lt/2, FNT);

	int [] data = set_time(); // ut lt
	String yy = YY+"/"+MM+"/"+DD;
	String dt = data[0]+"("+data[1]+"):"+MS;
	g.drawString(yy, 1, FNT);
	g.drawString(dt, 1, FNT*2);

	if (st >= 0) { // $B@1%G!<%?(B
	    g.setColor(Color.green);
	    g.drawString(S[st].toString(),1,FNT*3);
	}
    }
    public int [] set_time() {
	double rp = 24/PI2;
	int ut, ot;

	ut = (toDegrees(LD) < 180) ?  HH-(int)(LD*rp) :
	    HH+(int)(LD*rp); // $B@$3&;~(B
	if (ut <= 0)
	    ut += 24;
	else if (ut > 24)
	    ut -= 24;

	ot = (toDegrees(LG) < 180) ? ut+(int)(LG*rp) :
	    ut-(int)(LG*rp); // $B%m!<%+%k;~(B
	if (ot > 24)
	    ot -= 24;
	else if (ot <= 0)
	    ot += 24;

	int [] data = {ut, ot};
	return data;
    }
    public void disp_planet(Graphics g) {
	double [][] x = new double[3][Planets.length];
	TY = YY+(MM-1)/12+DD/365;
	T1 = JD-33281.92334;
	T1 *= (2.737909288E-5+1.260132857E-17*T1);
	T2 = T1*T1;
	int sun = 2;
	double mo, b, ra, dc, cc, ss, hagl, hgt, azmt;
	for (int i = 0; i < Planets.length; i++) {
	    set_planet(i);
	    eph_const(P[i], N[i], I[i]); // ->F/Q
	    mo = M[i]/PI2;
	    mo = PI2*(mo-(int)mo);
	    kepler(E[i], mo);
	    b = A[i]*Math.sqrt(1-E[i]*E[i]);
	    for (int j = 0; j < x.length; j++)
		x[j][i] = A[i]*F[j]*FF+b*Q[j]*SS;
	}
	for (int j = 0; j < x.length; j++) // sun
	    x[j][sun] = -x[j][sun];
	for (int i = 0; i < Planets.length; i++) {
	    if (i != sun)   // not earth
		for (int j = 0; j < x.length; j++)
		    x[j][i] += x[j][sun];
	}
	Point p;
	int pl = -1, mw = Dp;
	int dot = Dp, lm = dot/2+1;
	for (int i = 0; i < Planets.length; i++) {
	    ra = syogen(x[1][i], x[0][i]); // ss/cc->
	    dc = Math.atan(x[2][i]/(x[0][i]/Math.cos(ra)));
	    
	    hagl = LST-ra;
	    hgt = getHgt(dc, hagl); 
	    if (hgt < toRadians(1))
		continue;
	    azmt = getAzmt(dc, hagl);
	    if (azmt >= RG && azmt <= LF)
		continue;

	    p = hanen(azmt, hgt);
	    dot = (i == sun) ? Ds : Dp;
	    g.setColor(Pclr[i]);
	    g.fillOval(p.x-(dot/2), p.y-(dot/2), dot,dot);
	    if (i != sun) {
		g.drawLine(p.x-lm, p.y, p.x+lm, p.y);
		g.drawLine(p.x, p.y-lm, p.x, p.y+lm);
	    }
	    if (mX-mw < p.x && mX > p.x && mY-mw < p.y && mY > p.y)
		pl = i;
	}
	if (pl >= 0) {
	    g.setColor(Pclr[pl]);
	    g.drawString(Planets[pl], 1, FNT*3);
	}
    }
    public void disp_moon(Graphics g) {
	TA = (JD-15019.5)/36525;
	argument();
	moon();
	double [] data = position(Cm, MX, MY, MZ); // -> ra/dc/dl
 	double hagl = LST-data[0];
	double hgt = getHgt(data[1], hagl);
	if (hgt < toRadians(1))
	    return;
	double azmt = getAzmt(data[1], hagl);
	if (azmt >= RG && azmt <= LF)
	    return;

	int dot = Ds, mw = Ds-1;
	Point p = hanen(azmt, hgt);
	g.setColor(Color.white);
	g.drawOval(p.x-(dot/2), p.y-(dot/2), dot,dot);

	if (mX-mw < p.x && mX > p.x && mY-mw < p.y && mY > p.y)
	    g.drawString("Moon:"+df1.format((float)geturei()), 1, FNT*3);
    }
    public double geturei() {
	return Dm/PI2*29.4;
    }
    public double [] position(double r0, double r1, double r2, double r3) {
	double [] data = {
	    r0+Math.asin(r3/Math.sqrt(r2-r1*r1)), //ra
	    Math.asin(r1/Math.sqrt(r2)), //dc
	    Math.sqrt(r2)}; // dl
	return data;
    }
    public double toDRad(double x) {
	return PI2*(x/360-(int)(x/360));
    }
    public void argument() {
	double tb = TA*TA;
	Am = 296.104608+477000*TA+198.849108*TA+9.192E-3*tb;
	Am = toDRad(Am);
	Bm = 11.250889+483120*TA+82.02515*TA-3.211E-3*tb;
	Bm = toDRad(Bm);
	Cm = 270.434164+480960*TA+307.883142*TA-1.133E-3*tb;
	Cm = toDRad(Cm);
	Dm = 350.737486+444960*TA+307.114217*TA-1.436E-3*tb;
	Dm = toDRad(Dm);
	Em = 98.998753+35640*TA+359.372886*TA;
	Em = toDRad(Em);
	Gm = 358.475833+35999.04975*TA-1.5E-4*tb;
	Gm = toDRad(Gm);
	/*
	Jm = 225.444651+2880*TA+154.906654*TA;
	Jm = toDRad(Jm);
	Lm = 279.696678+36000.76892*TA+3.03E-4*tb;
	Lm = toDRad(Lm);
	Mm = 319.529425+19080*TA+59.8585*TA+1.81E-4*tb;
	Mm = toDRad(Mm);
	*/
	Nm = 259.183275-1800*TA-134.142008*TA+2.078E-3*tb;
	Nm = toDRad(Nm);
	/*
	Vm = 212.603219+58320*TA+197.803875*TA+1.286E-3*tb;
	Vm = toDRad(Vm);
	*/
	Wm = 342.767053+58320*TA+199.211911*TA+3.1E-4*tb;
	Wm = toDRad(Wm);
    }
    public void moon() {
	// moon-theta
	MX = -1.01E-3*Math.sin(Am+Bm-4*Dm);
	MX -= 1.02E-3*Math.sin(Am-Bm-4*Dm-Nm);
	MX -= 1.03E-3*TA*Math.sin(Am-Bm-Nm);
	MX -= 1.07E-3*Math.sin(Am-Gm-Bm-2*Dm-Nm);
	MX -= 1.21E-3*Math.sin(2*Am-Bm-4*Dm-Nm);
	MX += 1.3E-3*Math.sin(3*Am+Bm+Nm);
	MX -= 1.31E-3*Math.sin(Am+Bm-Nm);
	MX += 1.36E-3*Math.sin(Am+Bm-Dm+Nm);
	MX -= 1.45E-3*Math.sin(Gm+Bm);
	MX -= 1.49E-3*Math.sin(Am+Gm-Bm-2*Dm);
	MX += 1.57E-3*Math.sin(Gm-Bm+Dm-Nm);
	MX -= 1.59E-3*Math.sin(Gm-Bm);
	MX += 1.84E-3*Math.sin(Am-Gm+Bm-2*Dm+Nm);
	MX -= 1.94E-3*Math.sin(Bm-2*Dm-Nm);
	MX -= 1.96E-3*Math.sin(Gm-Bm+2*Dm-Nm);
	MX += 2E-3*Math.sin(Bm-Dm);
	MX -= 2.05E-3*Math.sin(Am+Gm-Bm);
	MX += 2.35E-3*Math.sin(Am-Gm-Bm);
	MX += 2.46E-3*Math.sin(Am-3*Bm-Nm);
	MX -= 2.62E-3*Math.sin(2*Am+Bm-2*Dm);
	MX -= 2.83E-3*Math.sin(Am+Gm+Bm-2*Dm);
	MX -= 3.39E-3*Math.sin(Gm-Bm-2*Dm-Nm);
	MX -= 3.45E-3*Math.sin(Am-Bm+Nm);
	MX -= 3.47E-3*Math.sin(Gm-Bm+2*Dm);
	MX -= 3.83E-3*Math.sin(Bm+Dm+Nm);
	MX -= 4.11E-3*Math.sin(Am+Gm+Bm+Nm);
	MX -= 4.42E-3*Math.sin(2*Am-Bm-2*Dm-Nm);
	MX += 4.49E-3*Math.sin(Am-Bm+2*Dm);
	MX -= 4.56E-3*Math.sin(3*Bm-2*Dm+Nm);
	MX += 4.66E-3*Math.sin(Am+Bm+2*Dm+Nm);
	MX += 4.9E-3*Math.sin(2*Am-Bm);
	MX += 5.61E-3*Math.sin(2*Am+Bm);
	MX += 5.64E-3*Math.sin(Am-Gm+Bm+Nm);
	MX -= 6.38E-3*Math.sin(Am+Gm-Bm-Nm);
	MX -= 7.13E-3*Math.sin(Am+Gm-Bm-2*Dm-Nm);
	MX -= 9.29E-3*Math.sin(Gm+Bm-2*Dm);
	MX -= 9.47E-3*Math.sin(2*Am-Bm-Nm);
	MX += 9.65E-3*Math.sin(Am-Gm-Bm-Nm);
	MX += 9.7E-3*Math.sin(Bm+2*Dm);
	MX += 0.01064*Math.sin(Bm-Dm+Nm);
	MX -= 0.0125*TA*Math.sin(Bm+Nm);
	MX -= 0.01434*Math.sin(Gm+Bm-2*Dm+Nm);
	MX -= 0.01652*Math.sin(Am+Gm+Bm-2*Dm+Nm);
	MX -= 0.01868*Math.sin(2*Am+Bm-2*Dm+Nm);
	MX += 0.027*Math.sin(2*Am+Bm+Nm);
	MX -= 0.02994*Math.sin(Am-Bm-2*Dm);
	MX -= 0.03759*Math.sin(Gm+Bm+Nm);
	MX -= 0.03982*Math.sin(Gm-Bm-Nm);
	MX += 0.04732*Math.sin(Bm+2*Dm+Nm);
	MX -= 0.04771*Math.sin(Bm-Nm);
	MX -= 0.06505*Math.sin(Am+Bm-2*Dm);
	MX += 0.13622*Math.sin(Am+Bm);
	MX -= 0.14511*Math.sin(Am-Bm-2*Dm-Nm);
	MX -= 0.18354*Math.sin(Bm-2*Dm);
	MX -= 0.20017*Math.sin(Bm-2*Dm+Nm);
	MX -= 0.38899*Math.sin(Am+Bm-2*Dm+Nm);
	MX += 0.40248*Math.sin(Am-Bm);
	MX += 0.65973*Math.sin(Am+Bm+Nm);
	MX += 1.96763*Math.sin(Am-Bm-Nm);
	MX += 4.95372*Math.sin(Bm);
	MX += 23.89684*Math.sin(Bm+Nm);
	//moon-rho
	MY = 0.05491*Math.cos(2*Am+Gm);
	MY += 0.0629*Math.cos(Am+Dm);
	MY -= 0.06444*Math.cos(4*Dm);
	MY -= 0.06652*Math.cos(2*Am-Gm);
	MY -= 0.07369*Math.cos(Gm-4*Dm);
	MY += 0.08119*Math.cos(Am-3*Dm);
	MY -= 0.09261*Math.cos(Am+4*Dm);
	MY += 0.10177*Math.cos(Am-2*Bm+2*Dm);
	MY += 0.10225*Math.cos(Am+Gm+2*Dm);
	MY -= 0.10243*Math.cos(Am+2*Gm-2*Dm);
	MY -= 0.12291*Math.cos(2*Bm);
	MY -= 0.12291*Math.cos(2*Am-2*Bm);
	MY -= 0.12428*Math.cos(Am+Gm-4*Dm);
	MY -= 0.14986*Math.cos(3*Am);
	MY -= 0.1607*Math.cos(Am-Gm+2*Dm);
	MY -= 0.16949*Math.cos(Am-Dm);
	MY += 0.17697*Math.cos(Am+2*Bm-2*Dm);
	MY -= 0.18815*Math.cos(2*Am-4*Dm);
	MY -= 0.19482*Math.cos(2*Gm-2*Dm);
	MY += 0.22383*Math.cos(2*Bm-2*Dm);
	MY += 0.22594*Math.cos(3*Am-2*Dm);
	MY += 0.24454*Math.cos(2*Am+Gm-2*Dm);
	MY -= 0.31717*Math.cos(Gm+Dm);
	MY -= 0.36333*Math.cos(Am-4*Dm);
	MY += 0.47999*Math.cos(Am-Gm-2*Dm);
	MY += 0.63844*Math.cos(Gm+2*Dm);
	MY += 0.8617*Math.cos(Gm);
	MY += 1.50534*Math.cos(Am-2*Bm);
	MY -= 1.67417*Math.cos(Am+2*Dm);
	MY += 1.99463*Math.cos(Am+Gm);
	MY += 2.07579*Math.cos(Dm);
	MY -= 2.455*Math.cos(Am-Gm);
	MY -= 2.74067*Math.cos(Am+Gm-2*Dm);
	MY -= 3.83002*Math.cos(Gm-2*Dm);
	MY -= 5.37817*Math.cos(2*Am);
	MY += 6.60763*Math.cos(2*Am-2*Dm);
	MY -= 53.97626*Math.cos(2*Dm);
	MY -= 68.62152*Math.cos(Am-2*Dm);
	MY -= 395.13669*Math.cos(Am);
	MY += 3649.33705;
	//moon-phi
	MZ = -1E-3*Math.sin(Am-Gm-2*Bm-2*Nm);
	MZ -= 1E-3*Math.sin(Am+Gm-4*Dm);
	MZ += 1E-3*Math.sin(2*Am-Gm);
	MZ += 1.02E-3*Math.sin(Am-Gm+2*Dm);
	MZ -= 1.06E-3*Math.sin(2*Am-2*Bm-Nm);
	MZ -= 1.06E-3*Math.sin(2*Am-2*Bm-Nm);
	MZ -= 1.06E-3*Math.sin(2*Am+Nm);
	MZ -= 1.09E-3*Math.sin(Am+2*Bm-2*Dm);
	MZ -= 1.1E-3*Math.sin(2*Bm-Dm+2*Nm);
	MZ += 1.12E-3*Math.sin(4*Dm);
	MZ -= 1.22E-3*Math.sin(2*Am-Nm);
	MZ -= 1.22E-3*Math.sin(2*Am+2*Bm+Nm);
	MZ += 1.49E-3*Math.sin(Gm+2*Bm-2*Dm+2*Nm);
	MZ -= 1.57E-3*Math.sin(2*Am-4*Dm);
	MZ += 1.71E-3*Math.sin(Am+Gm+2*Bm-2*Dm+2*Nm);
	MZ -= 1.75E-3*Math.sin(2*Am+Gm-2*Dm);
	MZ -= 1.9E-3*Math.sin(2*Gm-2*Dm);
	MZ += 1.93E-3*Math.cos(Am+16*Em-18*Wm);
	MZ += 1.94E-3*Math.sin(2*Am+2*Bm-2*Dm+2*Nm);
	MZ += 2.01E-3*Math.sin(Gm-2*Dm-Nm);
	MZ += 2.01E-3*Math.sin(Gm+2*Bm-2*Dm+Nm);
	MZ -= 2.07E-3*Math.sin(Am+2*Gm-2*Dm);
	MZ -= 2.1E-3*Math.sin(2*Gm);
	MZ -= 2.13E-3*Math.sin(2*Dm-Nm);
	MZ -= 2.13E-3*Math.sin(2*Bm+2*Dm+Nm);
	MZ -= 2.15E-3*Math.sin(3*Am-2*Dm);
	MZ -= 2.47E-3*Math.sin(Am-4*Dm);
	MZ -= 2.53E-3*Math.sin(Am-2*Bm+2*Dm);
	MZ += 2.79E-3*Math.sin(2*Bm+2*Nm);
	MZ -= 2.8E-3*Math.sin(2*Am+2*Bm+2*Nm);
	MZ += 3.12E-3*Math.sin(3*Am);
	MZ -= 3.17E-3*Math.sin(Am+2*Bm);
	MZ -= 3.5E-3*Math.sin(Am+16*Em-18*Wm);
	MZ += 3.9E-3*Math.sin(Gm+2*Bm+2*Nm);
	MZ += 4.13E-3*Math.sin(Gm-2*Bm-2*Nm);
	MZ -= 4.9E-3*Math.sin(2*Nm);
	MZ -= 4.91E-3*Math.sin(2*Bm+2*Dm+2*Nm);
	MZ += 5.04E-3*Math.sin(Gm+Dm);
	MZ += 5.16E-3*Math.sin(Am-Dm);
	MZ -= 6.21E-3*Math.sin(Gm+2*Dm);
	MZ += 6.48E-3*Math.sin(Am-2*Bm-2*Dm-Nm);
	MZ += 6.48E-3*Math.sin(Am-2*Dm+Nm);
	MZ += 7E-3*Math.sin(Am-Gm-2*Dm);
	MZ += 0.01122*Math.sin(Am+2*Dm);
	MZ += 0.0141*Math.sin(Am-2*Dm-Nm);
	MZ += 0.0141*Math.sin(Am+2*Bm-2*Dm+Nm);
	MZ += 0.01424*Math.sin(Am-2*Bm);
	MZ += 0.01506*Math.sin(Am-2*Bm-2*Dm-2*Nm);
	MZ -= 0.01567*Math.sin(2*Bm-2*Dm);
	MZ += 0.02077*Math.sin(2*Bm-2*Dm+2*Nm);
	MZ -= 0.02527*Math.sin(Am+Gm);
	MZ -= 0.02952*Math.sin(Am-Nm);
	MZ -= 0.02952*Math.sin(Am+2*Bm+Nm);
	MZ -= 0.03487*Math.sin(Dm);
	MZ += 0.03684*Math.sin(Am-Gm);
	MZ -= 0.03983*Math.sin(2*Dm+Nm);
	MZ += 0.03983*Math.sin(2*Bm-2*Dm+Nm);
	MZ += 0.04037*Math.sin(Am+2*Bm-2*Dm+2*Nm);
	MZ += 0.04221*Math.sin(2*Am);
	MZ -= 0.04273*Math.sin(Gm-2*Dm);
	MZ -= 0.05566*Math.sin(2*Am-2*Dm);
	MZ -= 0.05697*Math.sin(Am+Gm-2*Dm);
	MZ -= 0.06846*Math.sin(Am+2*Bm+2*Nm);
	MZ -= 0.08724*Math.sin(Am-2*Bm-Nm);
	MZ -= 0.08724*Math.sin(Am+Nm);
	MZ -= 0.11463*Math.sin(2*Bm);
	MZ -= 0.18647*Math.sin(Gm);
	MZ -= 0.20417*Math.sin(Am-2*Bm-2*Nm);
	MZ += 0.59616*Math.sin(2*Dm);
	MZ += 1.07142*Math.sin(Nm);
	MZ -= 1.07447*Math.sin(2*Bm+Nm);
	MZ -= 1.28658*Math.sin(Am-2*Dm);
	MZ -= 2.4797*Math.sin(2*Bm+2*Nm);
	MZ += 6.32962*Math.sin(Am);
    }
    public String getAppletInfo() {
	return "This is a Planetarium applet v0.8";
    }
    public String [][] getParameterInfo() {
	return info;
    }
    private String[][] info = {
	{"longitude","double","$B7PEY(B.now your longitude(0~360)"},
	{"latiotude","double","$B0^EY(B.now your latiotude(-90~90"},
	{"data_file","file name","$B@1%G!<%?%U%!%$%k(B.star data file"},
	{"data_number","int","$B@1%G!<%??t(B.star data number"},
	{"0.","$B%+!<%=%k0LCV(B:","$B;k@~$N2sE>(B(0$B!A(B360$BEY(B)."},
	{"1.","$B:8%/%j%C%/(B:","$B;k@~2sE>$N(B off/on."},
	{"2.","$B%+!<%=%k0LCV(B:","$B@1L>$NI=<((B."},
	{"3.","$B:8%I%i%C%0(B:","$B0^EY!&7PEY$NJQ99(B"},
	{"4.","Shift$B%-!<$H:8%/%j%C%/(B:","$B@V7P!&@V0^@~$NI=<((B on/off."},
	{"5.","Ctrl$B%-!<$H:8%/%j%C%/(B:","$B@1:B$r@~$G7k$V(B on/off."},
	{"6.","$B1&%/%j%C%/(B:","$BI=<(2hLL$r(B1$B;~4V$:$D?J$a$k(B on/off."}
    };
    public void read_file(String fn) {
        BufferedReader bf;
	StringTokenizer tk;
        String line, s, hr = "";
	String tn, cs, li;
        int nm, pol, m, cnt = 0;
 	double ra = 0, dc = 0, ca = 0, dd = 0;
	error = "";

        try {
            URL url = new URL(getDocumentBase(), fn);
            bf = new BufferedReader(new InputStreamReader(url.openStream()));
	    while((line = bf.readLine()) != null) {
                tk = new StringTokenizer(line, ",");
		m = tk.countTokens();
                tn = "";
		cs = "";
		li = "";
		nm = 0;
		pol = 1;
                for(int j = 0; j < m; j++) { 
		    try {
                        s = tk.nextToken();
			switch(j) {
			case 0: nm = Integer.parseInt(s);
			    break;
			case 1: ra = Double.valueOf(s).doubleValue();
			    break;
			case 2: ra += Double.valueOf(s).doubleValue()/60;
			    break;
			case 3: ra += Double.valueOf(s).doubleValue()/3600;
			    break;
			case 4: if (s.startsWith("-"))
				pol = -1;
			    dc = Double.valueOf(s).doubleValue();
			    dc = Math.abs(dc);
			    break;
			case 5: dc += Double.valueOf(s).doubleValue()/60;
			    break;
			case 6: dc += Double.valueOf(s).doubleValue()/3600;
			    break;
			case 7: ca = Double.valueOf(s).doubleValue();
			    break;
			case 8: hr = s;
			    break;
			case 9: li = s; 
			    break;
			default:
			}
                    } 
                    catch (NoSuchElementException e0) {
                        error = "No Token.";
                    }
                    catch (Exception e) {
                        error = "Token over error.";
                    }
                }
		ra *= 15;
		dc *= pol;
                S[cnt++] = new Stars(nm, ra, dc, ca, hr, li);
            }
            bf.close();
        } catch (FileNotFoundException e1) {
            error = fn+" file not found.";
        } catch (IOException e2) {
            error = fn+" can not Open.";
        } catch (VirtualMachineError OutOfMemoryException) {
	    error = "Out of Memory.";
	}
    }
}